/* dvector.c

Functions to handle dynamic vectors

    Copyright (C) 1999, 2000 Conrado Badenas <Conrado.Badenas@uv.es>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "dvector.h"

#include "macros.h"
#include "number.h"
#include "memo.h"

void i_dvector(dVector *pdv,size_t nmax)
{
	pdv->n=0;
	if (nmax==0) nmax=16; /* In case of doubt, memo for sixteen elements */
	pdv->v=vector(pdv->nmax=nmax);
}

void l_dvector(dVector *pdv)
{
	(pdv->nmax)*=2;
	pdv->v=(Number*)myrealloc(pdv->v,pdv->nmax,sizeof(Number));
}

void f_dvector(dVector *pdv)
{
	f_vector(pdv->v,pdv->nmax);
	pdv->nmax=pdv->n=0;
}

Number g_dvector(dVector *pdv,size_t i)
{
	if (i>=pdv->n) FATAL3("g_dvector(): Could not get dv[%u] with "
		"dv.n=%u\n",i,pdv->n)
	return (pdv->v)[i];
}

void s_dvector(dVector *pdv,size_t i,Number elem)
{
	while (i>=pdv->nmax) l_dvector(pdv);
	if (i>=pdv->n) pdv->n=i+1;
	(pdv->v)[i]=elem;
}
